{
    This file is part of the Cheb's Game Engine,
    Copyright (c) 2004-2006 by Anton Rzheshevski (chebmaster@mail.ru),
      and contains source of the test module #013.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

 **********************************************************************}

{$ifdef fpc}
  {$unitpath ../../cge/src}
  {$includepath ../../cge/src} //note: it seems this shit doesn't work
                                 // (at least, partially).
                                 // The command-line switch -Fi is still needed.


  {$memory 10000, 10000}   //Both values have no meaning.
  // First one - because the DLLs use the host apps's stack,
  // Second one - because heap can grow dynamically.
{$endif}

{$include mo_globaldefs.h}

{$stackframes off}

library _demo001;

uses
  SysUtils,
  un_typedefs,
  mo_hub,
  mo_classes,
  mo_module,

  _demo001_main; // THE ONLY LINE YOU NEED TO MODIFY WHEN CREATING A NEW MODULE!

  procedure Initialize(SelfName, SessionPath, SavePath: PChar); export; stdcall;
  var
    t, stub: integer;
  begin
    GrandInitialize(MyModuleVersionMajor, MyModuleVersionMinor, MyModuleBuildNumber); //Here we go...
    AddLog(MI_VERSION_INFO,[MyModuleString, VersionToStr(MyModuleVersionMajor, MyModuleVersionMinor, MyModuleBuildNumber), CompileDate, CompileTime, CompilerVersion, CompileTarget]);
    RegClass(MyModuleType);
    CreateModule(MyModuleType, PCharToString(SelfName), PCharToString(SessionPath), PCharToString(SavePath));
  end;

  function HandleMessage (msg: TCbMessage; p0, p1, p2: integer): boolean; export; stdcall;
  begin
//if (msg = Re_OnPress) and (p0 = KEY_SPACE) then raise Exception.Create('Crash test!');
    Result:=InternalHandleMessage(msg, p0, p1, p2);
  end;

  procedure SetGetAddressCallbackProc(Addr: pointer); export; stdcall;
  begin
    RegisterProc:= Addr;
  end;
  
exports
  Initialize name 'cgemoduleinit',
  HandleMessage name 'sendmsg',
  SetGetAddressCallbackProc name 'setcallback';
begin
  // do nothing
end.
